﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using TXTextControl.Proofing;
namespace txspell_usercontextmenu
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        TXTextControl.MisspelledWord word;

        private void contextMenuStrip1_Opening(object sender, CancelEventArgs e)
        {
            // clear all items from the context menu
            contextMenuStrip1.Items.Clear();

            // get the conversion rate twips vs. pixel
            int dpi = (int)(1440 / textControl1.CreateGraphics().DpiX);

            // get the location of the mouse
            Point location = new Point((int)(textControl1.PointToClient(MousePosition).X * dpi), (int)(textControl1.PointToClient(MousePosition).Y * dpi));
            // get the misspelled word at the mouse locaion
            word = textControl1.MisspelledWords.GetItem(location);

            if (word == null)
                return;

            txSpellChecker1.CreateSuggestions(word.Text);

            // fill up the context menu
            foreach (Suggestion suggestion in txSpellChecker1.Suggestions)
            {
                ToolStripMenuItem item = new ToolStripMenuItem(suggestion.Text);
                // attach the click handler
                item.Click += new EventHandler(item_Click);

                contextMenuStrip1.Items.Add(item);
            }

            if (contextMenuStrip1.Items.Count == 0)
                contextMenuStrip1.Items.Add("No suggestions found.");
        }

        void item_Click(object sender, EventArgs e)
        {
            // replace the misspelled word with the clicked suggestion
            textControl1.MisspelledWords.Remove(word, ((ToolStripMenuItem)sender).Text);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            textControl1.IsSpellCheckingEnabled = true;
        }


    }
}
